xref: /linux/tools/perf/tests/shell/stat+std_output.sh (revision ae22a94997b8a03dcb3c922857c203246711f9d4)
1#!/bin/bash
2# perf stat STD output linter
3# SPDX-License-Identifier: GPL-2.0
4# Tests various perf stat STD output commands for
5# default event and metricgroup
6
7set -e
8
9# shellcheck source=lib/stat_output.sh
10. "$(dirname $0)"/lib/stat_output.sh
11
12stat_output=$(mktemp /tmp/__perf_test.stat_output.std.XXXXX)
13
14event_name=(cpu-clock task-clock context-switches cpu-migrations page-faults stalled-cycles-frontend stalled-cycles-backend cycles instructions branches branch-misses)
15event_metric=("CPUs utilized" "CPUs utilized" "/sec" "/sec" "/sec" "frontend cycles idle" "backend cycles idle" "GHz" "insn per cycle" "/sec" "of all branches")
16skip_metric=("stalled cycles per insn" "tma_" "retiring" "frontend_bound" "bad_speculation" "backend_bound")
17
18cleanup() {
19  rm -f "${stat_output}"
20
21  trap - EXIT TERM INT
22}
23
24trap_cleanup() {
25  cleanup
26  exit 1
27}
28trap trap_cleanup EXIT TERM INT
29
30function commachecker()
31{
32	local prefix=1
33
34	case "$1"
35	in "--interval")	prefix=2
36	;; "--per-thread")	prefix=2
37	;; "--system-wide-no-aggr")	prefix=2
38	;; "--per-core")	prefix=3
39	;; "--per-socket")	prefix=3
40	;; "--per-node")	prefix=3
41	;; "--per-die")		prefix=3
42	;; "--per-cache")	prefix=3
43	;; "--per-cluster")	prefix=3
44	esac
45
46	while read line
47	do
48		# Ignore initial "started on" comment.
49		x=${line:0:1}
50		[ "$x" = "#" ] && continue
51		# Ignore initial blank line.
52		[ "$line" = "" ] && continue
53		# Ignore "Performance counter stats"
54		x=${line:0:25}
55		[ "$x" = "Performance counter stats" ] && continue
56		# Ignore "seconds time elapsed" and break
57		[[ "$line" == *"time elapsed"* ]] && break
58
59		main_body=$(echo $line | cut -d' ' -f$prefix-)
60		x=${main_body%#*}
61		[ "$x" = "" ] && continue
62
63		# Skip metrics without event name
64		y=${main_body#*#}
65		for i in "${!skip_metric[@]}"; do
66			[[ "$y" == *"${skip_metric[$i]}"* ]] && break
67		done
68		[[ "$y" == *"${skip_metric[$i]}"* ]] && continue
69
70		# Check default event
71		for i in "${!event_name[@]}"; do
72			[[ "$x" == *"${event_name[$i]}"* ]] && break
73		done
74
75		[[ ! "$x" == *"${event_name[$i]}"* ]] && {
76			echo "Unknown event name in $line" 1>&2
77			exit 1;
78		}
79
80		# Check event metric if it exists
81		[[ ! "$main_body" == *"#"* ]] && continue
82		[[ ! "$main_body" == *"${event_metric[$i]}"* ]] && {
83			echo "wrong event metric. expected ${event_metric[$i]} in $line" 1>&2
84			exit 1;
85		}
86	done < "${stat_output}"
87	return 0
88}
89
90perf_cmd="-o ${stat_output}"
91
92skip_test=$(check_for_topology)
93check_no_args "STD" "$perf_cmd"
94check_system_wide "STD" "$perf_cmd"
95check_interval "STD" "$perf_cmd"
96check_per_thread "STD" "$perf_cmd"
97check_per_node "STD" "$perf_cmd"
98if [ $skip_test -ne 1 ]
99then
100	check_system_wide_no_aggr "STD" "$perf_cmd"
101	check_per_core "STD" "$perf_cmd"
102	check_per_cache_instance "STD" "$perf_cmd"
103	check_per_cluster "STD" "$perf_cmd"
104	check_per_die "STD" "$perf_cmd"
105	check_per_socket "STD" "$perf_cmd"
106else
107	echo "[Skip] Skipping tests for system_wide_no_aggr, per_core, per_die and per_socket since socket id exposed via topology is invalid"
108fi
109cleanup
110exit 0
111